// L3DTio_X.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "L3DTio_X.h"

#include "..\Plugin API\ExtAPI.h"
extern CExtAPI theAPI;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CL3DTio_XApp

BEGIN_MESSAGE_MAP(CL3DTio_XApp, CWinApp)
END_MESSAGE_MAP()


// CL3DTio_XApp construction

CL3DTio_XApp::CL3DTio_XApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CL3DTio_XApp object

CL3DTio_XApp theApp;


// CL3DTio_XApp initialization

BOOL CL3DTio_XApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}

bool __stdcall ExtInitPlugin(FARPROC pFunc, LPVOID hID) {
	return theApp.InitPlugin(pFunc, hID);
}
bool __stdcall ExtSaveMapFile(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, ZVAR hProgWnd) {
	return theApp.SaveMapFile(hMap, lpFileName, hFormat, hProgWnd);
}

bool CL3DTio_XApp::InitPlugin(FARPROC pFunc, LPVOID hID) {

	// initalise the API
	if(!theAPI.InitAPI(pFunc, hID)) {
		AfxMessageBox("CL3DTio_XApp::InitPlugin error:\r\n - cannot load L3DT functions");
		return false;
	}

	//
	// add any further initialisation here
	//

	// create my format
	ZFORMAT hFormat = theAPI.format_Create("Heightfield", "DirectX mesh file", "x", "DirectX");
	if(!hFormat) {
		// do nothing; this probably means the format already exists.
	} else {

		// set the flags
		theAPI.format_SetFlags(hFormat, false, false); // native I/O and mosaic

		// set the options
		/*
		bool IsText = false;
		theAPI.format_SetOptionValue(hFormat, "IsText", VarID_bool, &IsText);
		*/
	}

	return true;
}

bool CL3DTio_XApp::SaveMapFile(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, ZVAR hProgWnd) {

	// check the map type
	switch(theAPI.map_GetMapType(hMap)) {
	default:
		theAPI.ReportError("CL3DTio_XApp::SaveMapFile error:\r\n - unsupported map type");
		return false;
	case MAP_Heightfield:
		// OK
		break;
	}

	bool IsText = true;
	/*
	theAPI.format_GetOptionValue(hFormat, "IsText", VarID_boolm &IsText); 
	if(!IsText) {
		ReportError("CL3DTio_XApp::SaveX error:\r\n - binary format not supported yet");
		return false;
	}
	*/

	float HFpxl;
	FILE *fp;

	// opening file for writing
	fp=fopen(lpFileName, "w"); 
	if(fp==NULL) {
		CString TempStr;
		TempStr.Format("CL3DTio_XApp::SaveX error\r\n - cannot create file '%s'", lpFileName);
		theAPI.ReportError(TempStr);
		return false;
	}

	long nx = theAPI.map_GetWidth(hMap);
	long ny = theAPI.map_GetHeight(hMap);
	float HorizScale = theAPI.map_GetHorizScale(hMap);

	if(nx<=0||ny<=0) {
		theAPI.ReportError("CL3DTio_XApp::SaveX error\r\n - invalid map size");
		return false;
	}


	// preparing sizes
	UINT nVertices = nx * ny;
	UINT nFaces = 2*(nx-1)*(ny-1);

	// preparing progress bar
	__int64 p, q, pmax, qstep;
	MSG TempMSG;
	if(hProgWnd) {
		theAPI.progbox_SetTitle(hProgWnd, "Saving X");
		theAPI.progbox_ShowWnd(hProgWnd);
		pmax = nx * ny + (nx-1) * (ny-1);
		qstep = (__int64)pmax/50; // HACK!
		if(qstep<1)	qstep=1;
		else 		pmax=50;
		q=0, p=0;
	}

	// writing header
	
	// text version
	fprintf(fp, "xof 0302txt 0032");

	// writing mesh template
	fprintf(fp, "\n\ntemplate Mesh {");
	fprintf(fp, "\n<3D82AB44-62DA-11cf-AB39-0020AF71E433>");
	fprintf(fp, "\nDWORD nVertices;");
	fprintf(fp, "\narray Vector vertices[nVertices];");
	fprintf(fp, "\nDWORD nFaces;");
	fprintf(fp, "\narray MeshFace faces[nFaces];");
	fprintf(fp, "\n[ ... ]");
	fprintf(fp, "\n}");

	// writing mesh
	fprintf(fp, "\n\nMesh TerrainMesh {");

	// writing vertex list
	fprintf(fp, "\n%d; // nVertices", nVertices);

//	UINT VertexID;
	int i, j;
	float x, y, z;

	for(j=0; j<ny; j++) {
	for(i=0; i<nx; i++) {

		if(hProgWnd) {
			if(q==qstep)	{ p++; q=0; }
			if(q++==0) {
				PeekMessage(&TempMSG, NULL, 0, 0, PM_REMOVE);
				theAPI.progbox_SetProgress(hProgWnd, p, pmax);
			}
		}
		
		theAPI.map_GetPixel(hMap, i, j, &HFpxl);
		
//		VertexID=i+nx()*j;		// not used
		x = HorizScale * (float)i;
		y = HorizScale * (float)j;
		z = HFpxl;

		fprintf(fp, "\n%f;%f;%f;", x, y, z);

		if(i == nx-1 && j == ny-1)
				fprintf(fp, ";");
		else	fprintf(fp, ",");
	}
	}

	
	// writing face list
	fprintf(fp, "\n\n%d; // nFaces (tri-mesh)", nFaces);

//	UINT FaceID;
	UINT A, B, C;

	for(j=0; j<ny-1; j++) {
	for(i=0; i<nx-1; i++) {

		if(hProgWnd) {
			if(q==qstep)	{ p++; q=0; }
			if(q++==0) {
				PeekMessage(&TempMSG, NULL, 0, 0, PM_REMOVE);
				theAPI.progbox_SetProgress(hProgWnd, p, pmax);
			}
		}

		// face 1
//		FaceID=2*(i+(nx()-1)*j); // not used
		A=i+nx*j;
		B=(i+1)+nx*j;
		C=i+nx*(j+1);

		fprintf(fp, "\n3,%d,%d,%d;,", A, B, C);

		// face 2
//		FaceID++;	// not used
		A=(i+1)+nx*j;
		B=i+nx*(j+1);
		C=(i+1)+nx*(j+1);

		fprintf(fp, "\n3,%d,%d,%d;", A, C, B);	// wound in other direction
		
		if(i == nx-2 && j == ny-2)
				fprintf(fp, ";");
		else	fprintf(fp, ",");
	}
	}

	fprintf(fp, "\n}");

	// closing file
	fclose(fp);

	if(hProgWnd) {
		theAPI.progbox_HideWnd(hProgWnd);
	}

	return true;
}